/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the Coupon type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Coupon{}

// Coupon struct for Coupon
type Coupon struct {
	Id string `json:"id"`
	Source string `json:"source"`
	Code string `json:"code"`
	ContactId string `json:"contact_id"`
	Status string `json:"status"`
	CreatedAt time.Time `json:"created_at"`
	RedeemedAt *time.Time `json:"redeemed_at,omitempty"`
	ExpiresAt *time.Time `json:"expires_at,omitempty"`
	Attributes *map[string][]string `json:"attributes,omitempty"`
	TransactionId *string `json:"transaction_id,omitempty"`
	InteractionId *string `json:"interaction_id,omitempty"`
	ActivityId *string `json:"activity_id,omitempty"`
	ConversationId *string `json:"conversation_id,omitempty"`
	TotalAmount *string `json:"total_amount,omitempty"`
	DisplayCode *string `json:"display_code,omitempty"`
	DisplayType string `json:"display_type"`
	Name string `json:"name"`
	Description *string `json:"description,omitempty"`
	Type *string `json:"type,omitempty"`
	Currency *string `json:"currency,omitempty"`
	Value *string `json:"value,omitempty"`
	ExpiresIn *int32 `json:"expires_in,omitempty"`
	LastSeenAt *time.Time `json:"last_seen_at,omitempty"`
	DisplayExpiresIn *int32 `json:"display_expires_in,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
}

// NewCoupon instantiates a new Coupon object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCoupon(id string, source string, code string, contactId string, status string, createdAt time.Time, displayType string, name string) *Coupon {
	this := Coupon{}
	this.Id = id
	this.Source = source
	this.Code = code
	this.ContactId = contactId
	this.Status = status
	this.CreatedAt = createdAt
	this.DisplayType = displayType
	this.Name = name
	return &this
}

// NewCouponWithDefaults instantiates a new Coupon object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCouponWithDefaults() *Coupon {
	this := Coupon{}
	return &this
}

// GetId returns the Id field value
func (o *Coupon) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Coupon) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Coupon) SetId(v string) {
	o.Id = v
}

// GetSource returns the Source field value
func (o *Coupon) GetSource() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Source
}

// GetSourceOk returns a tuple with the Source field value
// and a boolean to check if the value has been set.
func (o *Coupon) GetSourceOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Source, true
}

// SetSource sets field value
func (o *Coupon) SetSource(v string) {
	o.Source = v
}

// GetCode returns the Code field value
func (o *Coupon) GetCode() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Code
}

// GetCodeOk returns a tuple with the Code field value
// and a boolean to check if the value has been set.
func (o *Coupon) GetCodeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Code, true
}

// SetCode sets field value
func (o *Coupon) SetCode(v string) {
	o.Code = v
}

// GetContactId returns the ContactId field value
func (o *Coupon) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *Coupon) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *Coupon) SetContactId(v string) {
	o.ContactId = v
}

// GetStatus returns the Status field value
func (o *Coupon) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *Coupon) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *Coupon) SetStatus(v string) {
	o.Status = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *Coupon) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *Coupon) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *Coupon) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetRedeemedAt returns the RedeemedAt field value if set, zero value otherwise.
func (o *Coupon) GetRedeemedAt() time.Time {
	if o == nil || IsNil(o.RedeemedAt) {
		var ret time.Time
		return ret
	}
	return *o.RedeemedAt
}

// GetRedeemedAtOk returns a tuple with the RedeemedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetRedeemedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.RedeemedAt) {
		return nil, false
	}
	return o.RedeemedAt, true
}

// HasRedeemedAt returns a boolean if a field has been set.
func (o *Coupon) HasRedeemedAt() bool {
	if o != nil && !IsNil(o.RedeemedAt) {
		return true
	}

	return false
}

// SetRedeemedAt gets a reference to the given time.Time and assigns it to the RedeemedAt field.
func (o *Coupon) SetRedeemedAt(v time.Time) {
	o.RedeemedAt = &v
}

// GetExpiresAt returns the ExpiresAt field value if set, zero value otherwise.
func (o *Coupon) GetExpiresAt() time.Time {
	if o == nil || IsNil(o.ExpiresAt) {
		var ret time.Time
		return ret
	}
	return *o.ExpiresAt
}

// GetExpiresAtOk returns a tuple with the ExpiresAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetExpiresAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.ExpiresAt) {
		return nil, false
	}
	return o.ExpiresAt, true
}

// HasExpiresAt returns a boolean if a field has been set.
func (o *Coupon) HasExpiresAt() bool {
	if o != nil && !IsNil(o.ExpiresAt) {
		return true
	}

	return false
}

// SetExpiresAt gets a reference to the given time.Time and assigns it to the ExpiresAt field.
func (o *Coupon) SetExpiresAt(v time.Time) {
	o.ExpiresAt = &v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *Coupon) GetAttributes() map[string][]string {
	if o == nil || IsNil(o.Attributes) {
		var ret map[string][]string
		return ret
	}
	return *o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetAttributesOk() (*map[string][]string, bool) {
	if o == nil || IsNil(o.Attributes) {
		return nil, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *Coupon) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given map[string][]string and assigns it to the Attributes field.
func (o *Coupon) SetAttributes(v map[string][]string) {
	o.Attributes = &v
}

// GetTransactionId returns the TransactionId field value if set, zero value otherwise.
func (o *Coupon) GetTransactionId() string {
	if o == nil || IsNil(o.TransactionId) {
		var ret string
		return ret
	}
	return *o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetTransactionIdOk() (*string, bool) {
	if o == nil || IsNil(o.TransactionId) {
		return nil, false
	}
	return o.TransactionId, true
}

// HasTransactionId returns a boolean if a field has been set.
func (o *Coupon) HasTransactionId() bool {
	if o != nil && !IsNil(o.TransactionId) {
		return true
	}

	return false
}

// SetTransactionId gets a reference to the given string and assigns it to the TransactionId field.
func (o *Coupon) SetTransactionId(v string) {
	o.TransactionId = &v
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *Coupon) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *Coupon) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *Coupon) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetActivityId returns the ActivityId field value if set, zero value otherwise.
func (o *Coupon) GetActivityId() string {
	if o == nil || IsNil(o.ActivityId) {
		var ret string
		return ret
	}
	return *o.ActivityId
}

// GetActivityIdOk returns a tuple with the ActivityId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetActivityIdOk() (*string, bool) {
	if o == nil || IsNil(o.ActivityId) {
		return nil, false
	}
	return o.ActivityId, true
}

// HasActivityId returns a boolean if a field has been set.
func (o *Coupon) HasActivityId() bool {
	if o != nil && !IsNil(o.ActivityId) {
		return true
	}

	return false
}

// SetActivityId gets a reference to the given string and assigns it to the ActivityId field.
func (o *Coupon) SetActivityId(v string) {
	o.ActivityId = &v
}

// GetConversationId returns the ConversationId field value if set, zero value otherwise.
func (o *Coupon) GetConversationId() string {
	if o == nil || IsNil(o.ConversationId) {
		var ret string
		return ret
	}
	return *o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetConversationIdOk() (*string, bool) {
	if o == nil || IsNil(o.ConversationId) {
		return nil, false
	}
	return o.ConversationId, true
}

// HasConversationId returns a boolean if a field has been set.
func (o *Coupon) HasConversationId() bool {
	if o != nil && !IsNil(o.ConversationId) {
		return true
	}

	return false
}

// SetConversationId gets a reference to the given string and assigns it to the ConversationId field.
func (o *Coupon) SetConversationId(v string) {
	o.ConversationId = &v
}

// GetTotalAmount returns the TotalAmount field value if set, zero value otherwise.
func (o *Coupon) GetTotalAmount() string {
	if o == nil || IsNil(o.TotalAmount) {
		var ret string
		return ret
	}
	return *o.TotalAmount
}

// GetTotalAmountOk returns a tuple with the TotalAmount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetTotalAmountOk() (*string, bool) {
	if o == nil || IsNil(o.TotalAmount) {
		return nil, false
	}
	return o.TotalAmount, true
}

// HasTotalAmount returns a boolean if a field has been set.
func (o *Coupon) HasTotalAmount() bool {
	if o != nil && !IsNil(o.TotalAmount) {
		return true
	}

	return false
}

// SetTotalAmount gets a reference to the given string and assigns it to the TotalAmount field.
func (o *Coupon) SetTotalAmount(v string) {
	o.TotalAmount = &v
}

// GetDisplayCode returns the DisplayCode field value if set, zero value otherwise.
func (o *Coupon) GetDisplayCode() string {
	if o == nil || IsNil(o.DisplayCode) {
		var ret string
		return ret
	}
	return *o.DisplayCode
}

// GetDisplayCodeOk returns a tuple with the DisplayCode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetDisplayCodeOk() (*string, bool) {
	if o == nil || IsNil(o.DisplayCode) {
		return nil, false
	}
	return o.DisplayCode, true
}

// HasDisplayCode returns a boolean if a field has been set.
func (o *Coupon) HasDisplayCode() bool {
	if o != nil && !IsNil(o.DisplayCode) {
		return true
	}

	return false
}

// SetDisplayCode gets a reference to the given string and assigns it to the DisplayCode field.
func (o *Coupon) SetDisplayCode(v string) {
	o.DisplayCode = &v
}

// GetDisplayType returns the DisplayType field value
func (o *Coupon) GetDisplayType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DisplayType
}

// GetDisplayTypeOk returns a tuple with the DisplayType field value
// and a boolean to check if the value has been set.
func (o *Coupon) GetDisplayTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DisplayType, true
}

// SetDisplayType sets field value
func (o *Coupon) SetDisplayType(v string) {
	o.DisplayType = v
}

// GetName returns the Name field value
func (o *Coupon) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *Coupon) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *Coupon) SetName(v string) {
	o.Name = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *Coupon) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *Coupon) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *Coupon) SetDescription(v string) {
	o.Description = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *Coupon) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *Coupon) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *Coupon) SetType(v string) {
	o.Type = &v
}

// GetCurrency returns the Currency field value if set, zero value otherwise.
func (o *Coupon) GetCurrency() string {
	if o == nil || IsNil(o.Currency) {
		var ret string
		return ret
	}
	return *o.Currency
}

// GetCurrencyOk returns a tuple with the Currency field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetCurrencyOk() (*string, bool) {
	if o == nil || IsNil(o.Currency) {
		return nil, false
	}
	return o.Currency, true
}

// HasCurrency returns a boolean if a field has been set.
func (o *Coupon) HasCurrency() bool {
	if o != nil && !IsNil(o.Currency) {
		return true
	}

	return false
}

// SetCurrency gets a reference to the given string and assigns it to the Currency field.
func (o *Coupon) SetCurrency(v string) {
	o.Currency = &v
}

// GetValue returns the Value field value if set, zero value otherwise.
func (o *Coupon) GetValue() string {
	if o == nil || IsNil(o.Value) {
		var ret string
		return ret
	}
	return *o.Value
}

// GetValueOk returns a tuple with the Value field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetValueOk() (*string, bool) {
	if o == nil || IsNil(o.Value) {
		return nil, false
	}
	return o.Value, true
}

// HasValue returns a boolean if a field has been set.
func (o *Coupon) HasValue() bool {
	if o != nil && !IsNil(o.Value) {
		return true
	}

	return false
}

// SetValue gets a reference to the given string and assigns it to the Value field.
func (o *Coupon) SetValue(v string) {
	o.Value = &v
}

// GetExpiresIn returns the ExpiresIn field value if set, zero value otherwise.
func (o *Coupon) GetExpiresIn() int32 {
	if o == nil || IsNil(o.ExpiresIn) {
		var ret int32
		return ret
	}
	return *o.ExpiresIn
}

// GetExpiresInOk returns a tuple with the ExpiresIn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetExpiresInOk() (*int32, bool) {
	if o == nil || IsNil(o.ExpiresIn) {
		return nil, false
	}
	return o.ExpiresIn, true
}

// HasExpiresIn returns a boolean if a field has been set.
func (o *Coupon) HasExpiresIn() bool {
	if o != nil && !IsNil(o.ExpiresIn) {
		return true
	}

	return false
}

// SetExpiresIn gets a reference to the given int32 and assigns it to the ExpiresIn field.
func (o *Coupon) SetExpiresIn(v int32) {
	o.ExpiresIn = &v
}

// GetLastSeenAt returns the LastSeenAt field value if set, zero value otherwise.
func (o *Coupon) GetLastSeenAt() time.Time {
	if o == nil || IsNil(o.LastSeenAt) {
		var ret time.Time
		return ret
	}
	return *o.LastSeenAt
}

// GetLastSeenAtOk returns a tuple with the LastSeenAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetLastSeenAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.LastSeenAt) {
		return nil, false
	}
	return o.LastSeenAt, true
}

// HasLastSeenAt returns a boolean if a field has been set.
func (o *Coupon) HasLastSeenAt() bool {
	if o != nil && !IsNil(o.LastSeenAt) {
		return true
	}

	return false
}

// SetLastSeenAt gets a reference to the given time.Time and assigns it to the LastSeenAt field.
func (o *Coupon) SetLastSeenAt(v time.Time) {
	o.LastSeenAt = &v
}

// GetDisplayExpiresIn returns the DisplayExpiresIn field value if set, zero value otherwise.
func (o *Coupon) GetDisplayExpiresIn() int32 {
	if o == nil || IsNil(o.DisplayExpiresIn) {
		var ret int32
		return ret
	}
	return *o.DisplayExpiresIn
}

// GetDisplayExpiresInOk returns a tuple with the DisplayExpiresIn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetDisplayExpiresInOk() (*int32, bool) {
	if o == nil || IsNil(o.DisplayExpiresIn) {
		return nil, false
	}
	return o.DisplayExpiresIn, true
}

// HasDisplayExpiresIn returns a boolean if a field has been set.
func (o *Coupon) HasDisplayExpiresIn() bool {
	if o != nil && !IsNil(o.DisplayExpiresIn) {
		return true
	}

	return false
}

// SetDisplayExpiresIn gets a reference to the given int32 and assigns it to the DisplayExpiresIn field.
func (o *Coupon) SetDisplayExpiresIn(v int32) {
	o.DisplayExpiresIn = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *Coupon) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Coupon) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *Coupon) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *Coupon) SetChannelId(v string) {
	o.ChannelId = &v
}

func (o Coupon) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Coupon) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["source"] = o.Source
	toSerialize["code"] = o.Code
	toSerialize["contact_id"] = o.ContactId
	toSerialize["status"] = o.Status
	toSerialize["created_at"] = o.CreatedAt
	if !IsNil(o.RedeemedAt) {
		toSerialize["redeemed_at"] = o.RedeemedAt
	}
	if !IsNil(o.ExpiresAt) {
		toSerialize["expires_at"] = o.ExpiresAt
	}
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	if !IsNil(o.TransactionId) {
		toSerialize["transaction_id"] = o.TransactionId
	}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.ActivityId) {
		toSerialize["activity_id"] = o.ActivityId
	}
	if !IsNil(o.ConversationId) {
		toSerialize["conversation_id"] = o.ConversationId
	}
	if !IsNil(o.TotalAmount) {
		toSerialize["total_amount"] = o.TotalAmount
	}
	if !IsNil(o.DisplayCode) {
		toSerialize["display_code"] = o.DisplayCode
	}
	toSerialize["display_type"] = o.DisplayType
	toSerialize["name"] = o.Name
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.Currency) {
		toSerialize["currency"] = o.Currency
	}
	if !IsNil(o.Value) {
		toSerialize["value"] = o.Value
	}
	if !IsNil(o.ExpiresIn) {
		toSerialize["expires_in"] = o.ExpiresIn
	}
	if !IsNil(o.LastSeenAt) {
		toSerialize["last_seen_at"] = o.LastSeenAt
	}
	if !IsNil(o.DisplayExpiresIn) {
		toSerialize["display_expires_in"] = o.DisplayExpiresIn
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	return toSerialize, nil
}

type NullableCoupon struct {
	value *Coupon
	isSet bool
}

func (v NullableCoupon) Get() *Coupon {
	return v.value
}

func (v *NullableCoupon) Set(val *Coupon) {
	v.value = val
	v.isSet = true
}

func (v NullableCoupon) IsSet() bool {
	return v.isSet
}

func (v *NullableCoupon) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCoupon(val *Coupon) *NullableCoupon {
	return &NullableCoupon{value: val, isSet: true}
}

func (v NullableCoupon) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCoupon) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


